import Taro from '@tarojs/taro'
import { Image, Button, View, Text } from '@tarojs/components'
import SpinBox from "@/components/Spin/SpinBox";
import CustomCard from '@/components/foodCards/CustomCard/index'

import { useState, useEffect } from "react";
import BottomMoadl from '@/components/BottomMoadl/index'
import RecommendedCard from '@/components/foodCards/RecommendedCard'
import Travel from '@/assets/icons/Travel/travel.png'
import ChangeNext from '@/assets/icons/Travel/ChangeNext.png'
import withLayout from '@/layouts'

import editImg from '@/assets/icons/Travel/editimg.png'
import CustomNav from '@/components/CustomNav'
import { deleteTravelItem, getTravelID, getRecommendList } from '@/services/travel'

import NewCustom from './NewCustom'
import './style.less'

export default withLayout((props) => {
  const { router, location } = props
  const { id, dayNum } = router.params



  const [loading, setLoading] = useState(false)
  const [bottomDayNum, setBottomDayNum] = useState(true)



  const [showCutover, setShowCutover] = useState([])
  const [travelCustom, setTravelCustom] = useState()


  const handleDelete = (res) => {
    setLoading(true)
    getTravelID(id).then(e => {
      setTravelCustom(e)
      setShowCutover(e.travelItemList)
      netx(e.travelItemList)
      setLoading(false)

    }).catch(r => {
      setLoading(false)

    })
  }



  const [dayNumber, setDayNumber] = useState(1)
  const sum = dayNum - dayNumber
  const [state, setstate] = useState(true)


  const addTextSum = () => {
    setDayNumber(dayNumber + 1)

    if (dayNumber == 1) {
      setstate(false)
    }



  }
  const minusTextSum = () => {
    setDayNumber(dayNumber - 1)
    if (dayNumber == 2) {
      setstate(true)

    }


  }


  const netx = (e) => {


    let a = e.filter((val) => {
      return val.dayOrder == dayNumber
    })
    setShowCutover(a)

  }

  const handelAddTravel = () => {
    setLoading(true)

    //获取我的行程。
    getTravelID(id).then(e => {
      setTravelCustom(e)
      setShowCutover(e.travelItemList)
      netx(e.travelItemList)
      setLoading(false)

    }).catch(e => {
      setLoading(false)

    })


  }

  useEffect(() => {
    if (dayNum == 1) {
      setBottomDayNum(false)
    } else {
      setBottomDayNum(true)

    }

    setLoading(true)

    //获取我的行程。
    getTravelID(id).then(e => {
      setTravelCustom(e)
      setShowCutover(e.travelItemList)
      netx(e.travelItemList)
      setLoading(false)

    }).catch(e => {
      setLoading(false)

    })


  }, [id, dayNumber])



  const onDelete = (e) => {

    const itemId = e
    Taro.showModal({
      title: '提示',
      content: '确定要删除吗',
      success: function (res) {
        if (res.confirm) {

          deleteTravelItem(id, itemId).then(val => {
            Taro.showToast({
              title: '删除成功',
              icon: 'none',
              duration: 1000
            })
            handleDelete()

          })
        } else if (res.cancel) {


        }
      }
    })

  }


  const [showFrame, setShowFrame] = useState(false)





  //行程推荐
  const setRecommend = () => {
    console.log('弹窗触发了。');


    setShowFrame(!showFrame)

  }

  const handelCancel = () => {
    Taro.redirectTo({ url: '/pages/MineUserAll/MyTravel/index' })
  }

  return (
    <view className='page-index'>
      {/* 
      frameTitle 标题
      flag 弹窗显示 true false
      ico 底部图标
      textNext 底部文字
      */}
      <BottomMoadl frameTitle='行程推荐' dayNumber={dayNumber} travelId={id} flag={showFrame} handelAddTravel={handelAddTravel} onRecommend={setRecommend} ico={ChangeNext} textNext='换一批' location={location} />

      <View className='box-content'>
        <View className='index-navbar'>
          <CustomNav title='定制行程' />
        </View>
        <scroll-view scrollY style='height: calc(100% - 75px);margin-bottom: 40px;' >

          <View className='TravelTitle'>
            {travelCustom?.title}<Image src={editImg} className='edit' ></Image>
          </View>
          <View className='index-container'>

            <SpinBox loading={loading}>

              <View className='View-box'>

                {
                  showCutover.map((item, index) =>

                    <CustomCard key={index} item={item} det={item} editable='1' travelId={item.travelId} onDelete={onDelete} />

                  )
                }
              </View>
            </SpinBox>
          </View>


          <View className='tuijian' onClick={setRecommend}>
            <Image src={Travel}></Image>
            <Text>查看行程推荐</Text>
          </View>


          {
            bottomDayNum &&
            <View className='bottom'>
              {

                // dayNumber >= dayNum && <Button className='bottom-btn bottom-btn-cancel' onClick={minusTextSum} >上一天</Button>
                state === false && <Button className='bottom-btn bottom-btn-cancel' onClick={minusTextSum} >上一天</Button>
              }
              {
                sum >= 1 && <Button className='bottom-btn bottom-btn-ok' onClick={addTextSum}>下一天</Button>
              }

            </View>
          }


        </scroll-view>
      </View >
    </view>

  )
})